# et - the trivial time tracker
# Copyright 2014 Ethan Blanton
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along
#   with this program; if not, write to the Free Software Foundation, Inc.,
#   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

_et() {
    local cur=${COMP_WORDS[COMP_CWORD]}

    if [[ $COMP_CWORD -eq 1 ]]; then
        COMPREPLY=($(compgen -W "$($1 complete command)" -- $cur))
	return 0
    else
        local prev=${COMP_WORDS[COMP_CWORD - 1]}
        case $prev in
            -s|--subtask)
                _ettasks $1 $2
                return 0
                ;;
            -d|--directory)
                _filedir
                return 0
                ;;
        esac

        # The previous word wasn't a recognized option, check the
        # overall command to see if it takes a particular type
        case ${COMP_WORDS[1]} in
	    add_task)
		_ettasks $1 $2
		;;
	    move_task)
		_ettasks $1 $2
		;;
	    describe_task)
		_ettasks $1 $2
		;;
	    checkin|ci)
		_ettasks $1 $2
		;;
            -s|--subtask)
                _ettasks $1 $2
                ;;
        esac
    fi
}

_ettasks() {
    local cmd=$1
    local word=$2
    COMPREPLY=($(compgen -W "$($cmd complete task)" -- $word))
    return 0
}


complete -F _et et
