require 'test/unit'

require 'etduration'

class ETDuration_Basic_Test < Test::Unit::TestCase
    def checkraise(type = nil, &b)
        caught = false
        if (type)
            begin
                yield
            rescue type
                caught = true
            end
        else
            begin
                yield
            rescue
                caught = true
            end
        end
        assert(caught)
    end

    def test_parse
        assert(ETDuration.parse("10s").seconds == 10)
        assert(ETDuration.parse("10m").seconds == 600)
        assert(ETDuration.parse("10h").seconds == 36000)
        assert(ETDuration.parse("10d").seconds == 60*60*24*10)
        assert(ETDuration.parse("10:10").seconds == 610)
        assert(ETDuration.parse("10m10s").seconds == 610)
        assert(ETDuration.parse("10").seconds == 10)
        checkraise(ArgumentError) { ETDuration.parse("foo") }
        checkraise(ArgumentError) { ETDuration.parse("10:60") }
        checkraise(ArgumentError) { ETDuration.parse("10:100") }
        checkraise(ArgumentError) { ETDuration.parse("10m60s") }
        checkraise(ArgumentError) { ETDuration.parse("10m100s") }
    end
end
