module ETTest
    @@TaskTree = {
        "tid" => "ROOT",
        "uuid" => "1",
        "description" => "Root task",
        "inactive" => false,
        "subtasks" =>
        [
         {
             "tid" => "C1",
             "uuid" => "2",
             "description" => "Root child 1",
             "inactive" => false,
             "subtasks" =>
             [
              {
                  "tid" => "G1",
                  "uuid" => "3",
                  "description" => "Root grandchild 1",
                  "inactive" => true,
                  "subtasks" => []
              },
              {
                  "tid" => "G2",
                  "uuid" => "4",
                  "description" => "Root grandchild 2",
                  "inactive" => false,
                  "subtasks" => []
              }
             ]
         },
         {
             "tid" => "C2",
             "uuid" => "5",
             "description" => "Root child 2",
             "inactive" => false,
             "subtasks" => []
         }
        ]
    }

    def checkraise(type = nil, &b)
        caught = false
        if (type)
            begin
                yield
            rescue type
                caught = true
            end
        else
            begin
                yield
            rescue
                caught = true
            end
        end
        assert(caught)
    end

    def checktask(task, tid, desc, nsub, parent, active)
        assert(task.tid == tid)
        assert(task.description == desc)
        assert(task.subtasks.length == nsub)
        assert(task.parent == parent) if parent
        assert(!task.inactive == !!active)
    end

    def checktasks(t1, t2)
        assert(t1.tid == t2.tid)
        assert(t1.description == t2.description)
        if t1.parent
            assert(t2.parent)
            assert(t1.parent.UUID == t2.parent.UUID)
        else
            assert(t2.parent == nil)
        end
        assert(t1.inactive == t2.inactive)
        assert(t1.UUID == t2.UUID)
        subtasks1 = t1.subtasks
        subtasks2 = t2.subtasks
        while not subtasks1.empty?
            st1 = subtasks1.pop
            st2 = subtasks2.pop
            assert(st2)
            checktasks(st1, st2)
        end
    end
end
